#include "aClient.h"
#include <stdlib.h>
#include <stdio.h>

aClient::aClient(char *n)
{
    cout << "aClient created: " 
	 << (n[0] == '\0' ? "NULL" : n) << endl;
    strcpy(nick, n);
    stats = NULL;
    flags = 0;
}

aClient::aClient(const aClient &right)
{
    cout << "aClient created from another aClient: " << right.nick 
	 << endl;
    stats = NULL;
    flags = 0;
    setData(&right);
}

aClient::aClient()
{
    aClient("");
    flags = 0;
}

aClient::~aClient()
{
    cout << "aClient deleted: " << *this << flush;
    if (stats)
    {
	cout << ' ' << stats->name << ' ' << stats->password << endl << flush;
	delete stats;
    }
    flags = 0;
    cout << endl << flush;
}

ostream &operator<<( ostream &out, const aClient &c )
{
    out << (c.nick[0] == '\0' ? "NULL" : c.nick);
    return out;
}

void aClient::setData(const aClient *right)
{
    if (right != this)
    {
	strcpy(nick, right->nick);
	if (right->stats)
	{
	    if (!stats)
		stats = new Player;

	    cout << "Should be setting data for " << right->stats->name << endl;
	    stats->setData(right->stats);
	}
    }
}

long int aClient::setFlags(long int newflags)
{
    flags = newflags;
    return getFlags();
}

long int aClient::addFlag(long int flag)
{
    flags |= flag;
    return getFlags();
}

long int aClient::remFlag(long int flag)
{
    flags &= ~flag;
    return getFlags();
}
